package org.xdoclet.plugin.castor.qtags;

public class CastorFieldXmlTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.castor.qtags.CastorFieldXmlTag {
    public static final String NAME = "castor.field-xml";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"name",
		"type",
		"location",
		"matches",
		"qname-prefix",
		"reference",
		"node",
		"auto-naming",
		"transient",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public CastorFieldXmlTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public CastorFieldXmlTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getName_() {
		boolean required = false;
        String result = getNamedParameter("name");
        if(required && result == null) {
            bomb("name=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getType() {
		boolean required = false;
        String result = getNamedParameter("type");
        if(required && result == null) {
            bomb("type=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getLocation() {
		boolean required = false;
        String result = getNamedParameter("location");
        if(required && result == null) {
            bomb("location=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getMatches() {
		boolean required = false;
        String result = getNamedParameter("matches");
        if(required && result == null) {
            bomb("matches=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getQnamePrefix() {
		boolean required = false;
        String result = getNamedParameter("qname-prefix");
        if(required && result == null) {
            bomb("qname-prefix=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public boolean isReference() {
		boolean required = false;
        String result = getNamedParameter("reference");
        if(required && result == null) {
            bomb("reference=\"???\" must be specified.");
        }

		boolean retVal = false;


		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }
    public java.lang.String getNode() {
		boolean required = false;
        String result = getNamedParameter("node");
        if(required && result == null) {
            bomb("node=\"???\" must be specified.");
        }

		java.lang.String retVal = null;

        if(result == null) {
            result = "text";
        }

		if (result != null) {
	            if( !(false || result.equals("element")|| result.equals("attribute")|| result.equals("text")) ) {
	                // todo we should say what file and line number too
	                bomb("node=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getAutoNaming() {
		boolean required = false;
        String result = getNamedParameter("auto-naming");
        if(required && result == null) {
            bomb("auto-naming=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            if( !(false || result.equals("deriveByClass")|| result.equals("deriveByField")) ) {
	                // todo we should say what file and line number too
	                bomb("auto-naming=\"" + result + "\" is an invalid parameter value.");
	            }
	            retVal = result;
		}
		
		return retVal;
    }
    public boolean isTransient() {
		boolean required = false;
        String result = getNamedParameter("transient");
        if(required && result == null) {
            bomb("transient=\"???\" must be specified.");
        }

		boolean retVal = false;

        if(result == null) {
            result = "false";
        }

		if (result != null) {
		        retVal = Boolean.valueOf(result).booleanValue();
		}
		
		return retVal;
    }

    protected void validateLocation() {
		if(isOnClass) {
        	bomb("is not allowed on classes");
		}
		if(isOnConstructor) {
        	bomb("is not allowed on constructors");
		}
        
        // check uniqueness
        // deprecated here. check validateModel
		if(getContext().getTagsByName(NAME).length > 1) {
			bomb("is allowed only once");
		}

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getName_();
        getType();
        getLocation();
        getMatches();
        getQnamePrefix();
        isReference();
        getNode();
        getAutoNaming();
        isTransient();
    }

    public void validateModel() {
        // check uniqueness
        if(getContext().getTagsByName(NAME).length > 1) {
            bomb("is allowed only once");
        }
    }
}